#ifdef _WIN32
        #include <windows.h>
	#include <shlobj.h>
#endif

Particle::Particle()
{
	settings	= Settings::Instance();
	totalFrames	= 0;
	maxLifetime	= 25;
//	energyLevel	= 1;
//	molecule	= 1;

	color[0] = 1.0f;
	color[1] = 1.0f;
	color[2] = 1.0f;
	color[3] = 0.2f;
	
	size = 0.01f;

	energyLevel = 0;
	drugtype = 0;
	druglevel = 0;

	type = 99;
	isPicked = false; 
	killme = false;

/*	dummy_particle = new Particle;

	if (!dummy_particle_flag) {
		dummy_particle->energyLevel = 420;
		dummy_particle->molecule = 5;
	        dummy_particle->color[0] = 0.0f;
	        dummy_particle->color[1] = 0.0f;
	        dummy_particle->color[2] = 0.0f;
	        dummy_particle->color[3] = 1.0f;
		dummy_particle->real_particle = this;
//		dummy_particle->dummy_particle_flag = true;
//		dummy_particle->createBody( m_dynamicsWorld, findPosition() );
	} */
}

void Particle::draw()
{
	myMotionState->m_graphicsWorldTrans.getOpenGLMatrix(position);
/*	btVector3 pos = myMotionState->m_graphicsWorldTrans.getOrigin();
	cerr << pos.getY() */
	
	glPushMatrix(); 
	glMultMatrixf(position);

			glColor4f( color[0], color[1], color[2], color[3] );
			glScaled(halfExtent[0], halfExtent[1], halfExtent[2]);
			Displaylists::Instance()->call(1);

	glPopMatrix();
}

void Particle::createBody(btDynamicsWorld* m_dynamicsWorld, const btVector3& startOffset, float r, float g, float b, float a, float xdest, float ydest, float zdest, float speed, float rx, float ry, float rz, unsigned int newtype, float foodlevel, unsigned int newdrugtype, float newdruglevel)
{
	body.m_ownerWorld = m_dynamicsWorld;

	// type of 99 (or other for now) is inedible particle
	// type of 100 is edible particle
	if (newtype>99) {
		type = newtype;
		energyLevel = foodlevel;
		if (newdruglevel>0) {
			drugtype = newdrugtype;
			druglevel = newdruglevel;
		}
	}

	btTransform offset; offset.setIdentity();
	offset.setOrigin(startOffset);

	size += ((float) randgen->Instance()->get(1,400))/10000.0f;
	maxLifetime += randgen->Instance()->get(1,maxLifetime*3);
	float weight = 0.005f+((float)randgen->Instance()->get(1,100))/10000.0f;
//	float weight = (float)(randgen->Instance()->get(1,10));
//	cout << xdest << " " << ydest << " " << zdest << endl;

//	float xdir = 0;
//	float ydir = 0;
//	float zdir = 0;
//	float weight = 11.0f;
//	size = 0.01f;

	btTransform transform; transform.setIdentity();
	transform.setOrigin( btVector3(0.0f, 0.10f, 0.0f) );
//	transform.setOrigin( btVector3(xdir, ydir, zdir) ); // forget this

	body.addBodyPart_Box((void*)this, size, size, size, weight, offset, transform, xdest, ydest, zdest, speed, rx, ry, rz);

	myMotionState = (btDefaultMotionState*)body.bodyparts[0]->body->getMotionState();
	boxShape = static_cast<btBoxShape*>(body.bodyparts[0]->shape);
	halfExtent = boxShape->getHalfExtentsWithMargin();

	color[0] = r;
	color[1] = g;
	color[2] = b;
	color[3] = a;

}

Particle::~Particle()
{
//	cout << "dummy_particle destroyed" << endl;
//	delete dummy_particle;
}
