#include "statsgraph.h"

Statsgraph::Statsgraph()
{
	active = false;
	isMovable = true;

	statsBuffer = Statsbuffer::Instance();

	v_width = 300;
	v_height = 150;
	
	position.x = 10;
	position.y = 50;
}

void Statsgraph::draw()
{
	if (active)
	{
		// hack
		v_width = *parent->v_widthP - 20;

// 		updateAbsPosition();
		drawBackground();
		drawBorders();

		int number = statsBuffer->snapshots.size();
		
		if ( number > 0 )
		{
			int start = 0;
			if ( number > (int)v_width )
				start = number - v_width;
			
		// find the highest value in the stats vector
			unsigned int highest = 0;
			for ( int i=start; i < number; i++ )
			{
/*				unsigned int sum = statsBuffer->snapshots[i].food + statsBuffer->snapshots[i].critters;
				if ( sum > highest )
					highest = sum;*/
// 				unsigned int sum = statsBuffer->snapshots[i].food + statsBuffer->snapshots[i].critters;
				if ( statsBuffer->snapshots[i].food / 3.0f> highest )
					highest = statsBuffer->snapshots[i].food / 3.0f;
				if ( statsBuffer->snapshots[i].critters > highest )
					highest = statsBuffer->snapshots[i].critters;
//				if ( (int) (statsBuffer->snapshots[i].ad / 80.0f) > highest )         // flamoot
//					highest = (int) (statsBuffer->snapshots[i].ad / 80.0f);       // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].avgneur / 300.0f) > highest )              // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].avgneur / 300.0f);            // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].avgsyn / 4000.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].avgsyn / 4000.0f);   // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].synvneur * 7.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].synvneur * 7.0f);   // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].drugtotlev / 150000.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].drugtotlev / 150000.0f);   // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].drugonelev * 300.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].drugonelev * 300.0f);   // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].drugtwolev * 300.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].drugtwolev * 300.0f);   // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].drugthrlev * 300.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].drugthrlev * 300.0f);   // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].drugfoulev * 300.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].drugfoulev * 300.0f);   // flamoot
				if ( (unsigned int) (statsBuffer->snapshots[i].drugfivlev * 300.0f) > highest )     // flamoot
					highest = (unsigned int) (statsBuffer->snapshots[i].drugfivlev * 300.0f);   // flamoot


			}
// 			cerr << highest << endl;

			if ( highest > 0 )
			{
				// so,  highest ~ v_height
				// and, number ~ boxwidth
				float heightratio = ((float)v_height/highest);
			
			// draw the number of critters graph
				glColor3f(0.0f, 0.6f, 0.0f);
				glBegin(GL_LINES);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height-(heightratio*statsBuffer->snapshots[i].food / 3.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height-(heightratio*statsBuffer->snapshots[i+1].food / 3.0f) );
					}
// 				glEnd();

					
// flamoot follows					
//				glColor3f(0.6f, 0.6f, 0.9f);
//					for ( int i=start; i < number-1; i++ )
//					{
//						glVertex2f( position.x+i-start, position.y+v_height-(int) (heightratio*(statsBuffer->snapshots[i].ad / 80.0f)) );
//						glVertex2f( position.x+i+1-start, position.y+v_height-(int) (heightratio*(statsBuffer->snapshots[i+1].ad / 80.0f)) );
//					}

				glColor3f(0.0f, 0.7f, 0.7f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height-(unsigned int) (heightratio*statsBuffer->snapshots[i].avgsyn / 4000.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height-(unsigned int) (heightratio*statsBuffer->snapshots[i+1].avgsyn / 4000.0f) );
					}

				glColor3f(0.1f, 0.5f, 0.5f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].synvneur * 7.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].synvneur * 7.0f) );
					}

				glColor3f(0.3f, 0.3f, 0.8f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].avgneur / 300.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].avgneur / 300.0f) );
					}

				glColor3f(0.7f, 0.7f, 0.7f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].drugtotlev / 150000.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].drugtotlev / 150000.0f) );
					}


				glColor3f(0.0f, 0.0f, 0.55f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].drugonelev * 300.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].drugonelev * 300.0f) );
					}

				glColor3f(0.0f, 0.0f, 0.95f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].drugtwolev * 300.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].drugtwolev * 300.0f) );
					}

				glColor3f(0.55f, 0.0f, 0.0f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].drugthrlev * 300.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].drugthrlev * 300.0f) );
					}

				glColor3f(0.95f, 0.0f, 0.0f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].drugfoulev * 300.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].drugfoulev * 300.0f) );
					}

				glColor3f(0.9f, 0.0f, 0.9f);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i].drugfivlev * 300.0f) );
						glVertex2f( position.x+i+1-start, position.y+v_height- (unsigned int) (heightratio*statsBuffer->snapshots[i+1].drugfivlev * 300.0f) );
					}

// flamoot ends

				glColor3f(0.6f, 0.0f, 0.0f);
// 				glBegin(GL_LINES);
					for ( int i=start; i < number-1; i++ )
					{
						glVertex2f( position.x+i-start, position.y+v_height-(heightratio*statsBuffer->snapshots[i].critters) );
						glVertex2f( position.x+i+1-start, position.y+v_height-(heightratio*statsBuffer->snapshots[i+1].critters) );
					}

				glEnd();
			}
		}
		
	}
}

Statsgraph::~Statsgraph()
{
}
