#include "file.h"

File::File()
{
}

bool File::exists(string &file)
{
	return exists( file.c_str() );
}

bool File::exists(const char* file)
{
	fstream file_op(file,ios::in);
	if (file_op.is_open())
	{
		file_op.close();
		return true;
	}
	else return false;
}

void File::rm(const string &filename)
{
	if( remove( filename.c_str() ) != 0 )
		cerr << "Error deleting file" << endl;
// 	else
// 		cerr << "file succesfully deleted" << endl;
}

void File::save(const string &filename, const string& content)
{
	fstream file_op(filename.c_str(),ios::out);
	file_op << content;
	file_op.close();
}

void File::save(const string &filename, string* content)
{
	fstream file_op(filename.c_str(),ios::out);
	file_op << *content;
	file_op.close();
}

bool File::open(const string &filename, string &content, unsigned int binlength)
{
	content.clear();
	char str[20000];
//	string str;

	fstream file_op(filename.c_str(),ios::in);
	if (file_op)
	{
		while ( !file_op.eof() )
		{
			int ctr = 0;
			if (!binlength) {
				file_op.getline(str,20000);
				content.append(str);
				content.append("\n");
			} else { // binary mode doesnt work
			
//				file_op.get(str, binlength);
//				content.append(str);
				short signed int s;
//				unsigned char s;
				for (ctr=0;ctr < binlength;ctr++) {
					s = file_op.get();
					if (s > -1) {
						sprintf(str, "%c", (unsigned char) s);
						cout << "char is "<< s <<  (unsigned char) s << endl;
						content.append(str);
					}
//					cout << "char ctr " << ctr << endl;
					if (file_op.eof()) {break;}
				}
			}
		}
		file_op.close();
		return true;
	}
	else return false;
}

bool File::open(const char* filename, string &content, unsigned int binlength)
{
	content.clear();
	char str[20000];

	fstream file_op(filename,ios::in);
	if (file_op)
	{
		while ( !file_op.eof() )
		{
			int ctr = 0;
			if (!binlength) {
				file_op.getline(str,20000);
				content.append(str);
				content.append("\n");
			} else { // binary mode doesnt work
//				file_op.get(str, binlength);
//				content.append(str);
				short signed int s;
//				unsigned char s;
				for (ctr=0;ctr < binlength;ctr++) {
					s = file_op.get();
					if (s > -1) {
						sprintf(str, "%c", (unsigned char) s);
						cout << "char is "<< s << (unsigned char) s << endl;
						content.append(str);
					}
//					cout << "char ctr " << ctr << endl;
					if (file_op.eof()) {break;}
				}
			}
		}
		file_op.close();
		return true;
	}
	else return false;
}

bool File::openbin(const string &filename, int *content, unsigned int binlength) // works
{
	fstream file_op(filename.c_str(),ios::in);
	if (file_op)
	{
		while ( !file_op.eof() )
		{
			int ctr = 0;
			int s;
//			unsigned char s;
			for (ctr=0;ctr < binlength;ctr++) {
				s = file_op.get();
				if (s > -1) {
//					cout << "char is "<< s << endl;
					content[ctr] = s;
				}
//				cout << "char ctr " << ctr << endl;
				if (file_op.eof()) {break;}
			}
			
		}
		file_op.close();
		return true;
	}
	else return false;
}


File::~File()
{
}

